<template>
  <div class="hello">
    <div class="container">
      <div class="item item--fill">
        <Card>
          <template v-slot:header>
            <h1>{{name}}</h1>
          </template>
          <template v-slot:body>
            <component :is="name" v-bind="state.props"/>
          </template>
        </Card>
      </div>
      <div class="item item--fill" v-if="component_props.length">
        <Card>
          <template v-slot:header>
            <h1>Props</h1>
          </template>
          <template v-slot:body>
            <label v-for="(prop) in component_props" :key="prop.key" class="prop">
              <span>{{prop.key}}:</span>
              <input v-if="prop.type === String" type="text" v-model="state.props[prop.key]">
              <input v-if="prop.type === Number" type="text" v-model="state.props[prop.key]">
              <input v-if="prop.type === Boolean" type="checkbox" v-model="state.props[prop.key]">
            </label>
          </template>
        </Card>
      </div>
    </div>
  </div>
</template>

<script>
import { reactive, onMounted } from "vue";
import { useRoute } from "vue-router";
import Card from "../../components/Card";
import site_components from "sc/index";

export default {
  components: {
    Card,
    ...site_components.components
  },
  setup(){
    const route = useRoute();
    const props_raw = site_components.components[route.params.component.split('').map((char, index)=>index==0?char.toUpperCase():char).join('')].props || {};
    const component_props = Object.keys(props_raw).map(key=>({key, type: props_raw[key].type, default: props_raw[key].default, value: props_raw[key].default || ""}));
    const state = reactive({props: Object.fromEntries(Object.keys(props_raw).map(key=>([key, props_raw[key].default])))})

    onMounted(async ()=>{});

    console.log(state.props);

    return {
      name: route.params.component.split('').map((char, index)=>index==0?char.toUpperCase():char).join(''),
      component_props,
      state
    }
  }
}
</script>

<style scoped lang="scss">
  .container{
    display: flex;
    flex-wrap: wrap;
    margin: 0 -16px;

    >.item{
      width: calc(100% / 3 - 16px);
      margin: 8px;
      height: auto;

      &.item--fill{
        width: 100%;
      }
    }
  }

  .prop{
    display: flex;
    align-items: center;
    span{
      margin-right: 8px;
      font-size: 16pt;
    }
    input{
      margin: 0;
      height: 20px;
      min-width: 20px;
    }
  }
</style>
